dofile(reaper.AZ_GetLuaInitPath())
require("reaper_AZSTOKE_SILVER")

trackNameList = {"pl0000","pl1000","pl2000","pl3000","pl4000"}
trackColorList = {33554304,33521664,25165824,16777471,21004543}

retval,inputList = reaper.AZ_GetUserInputList("SourceImportPath",1,"Path :","D:/")

if retval then
--Get Master Select Track 
   masterTrack = reaper.AZ_GetTrackItemSelect(0,0,1)
   masterName = reaper.AZ_GetTrackItemName(masterTrack)
   masterDepth = reaper.AZ_GetTrackItemDepth(masterTrack)

   for i, value in pairs(trackNameList) do
       if masterName == trackNameList[i] then
          reaper.AZ_SetTrackItemColor(masterTrack,trackColorList[i])
          masterColor = trackColorList[i]
       end
   end

--Get FileList
   fileAllList = {}
   fileList = reaper.AZ_GetFilePathList(inputList[1],"Wav")
   for i, value in pairs(fileList) do
       splitList = reaper.AZ_GetStringSplitList(value,"\\")
       splitCount = 0
      for e, sp in pairs(splitList) do
          splitCount = splitCount + 1
      end
      fileAllList[i] = {}
      fileAllList[i]["Path"] = value
      fileAllList[i]["SourceName"] =  reaper.AZ_ReplaceSearchString(splitList[splitCount],".wav","")
   end
   
   
--Get Master Track Children
   childList,masterChildCount = reaper.AZ_GetTrackItemChildList(masterTrack)

   childInfoList = {}
   for i, value in pairs(childList) do
       childInfoList[i] = {}
       childInfoList[i]["TrackName"]= reaper.AZ_GetTrackItemName(value)
       reaper.AZ_SetTrackItemColor(value,masterColor)
       childInfoList[i]["TrackMediaCount"] = reaper.AZ_GetTrackItemMediaTypeCount(value,"")
       childId = reaper.AZ_GetTrackItemIndex(value)
    
       for e = 1,childInfoList[i].TrackMediaCount do
           childInfoList[i][e] = {}
           childInfoList[i][e]["MediaName"] = reaper.AZ_GetTrackMediaName(0,childId,e-1)
           childInfoList[i][e]["MediaPos"]= reaper.AZ_GetTrackMediaStartTimeSeconds(0,childId,e-1)
       end
    end

--delet trackNameList & trackBaseList create 
    trCount = reaper.AZ_GetTrackCountSelect(0,0)
    deletIDList = {}
    idCount = 0

    for i = 0,trCount-1 do
        name = reaper.AZ_GetTrackIdName(0,i)
        for i, value in pairs(trackNameList) do
            if name == value then
               idCount = idCount + 1
               deletIDList[idCount] = i
            end
        end
    end

    table.sort(deletIDList,function(a,b) return (a>b)end)

    for i = 1,idCount do
        table.remove(trackNameList,deletIDList[i])
        table.remove(trackColorList,deletIDList[i])
    end



--InsertTrack
    for i, value in pairs(trackNameList) do
        count = reaper.AZ_GetTrackCountSelect(0,0)
        track = reaper.AZ_InsertTrackId(0,count)
        reaper.AZ_SetTrackItemName(track,value)
        reaper.AZ_SetTrackItemDepth(track,masterDepth)
        reaper.AZ_SetTrackItemColor(track,trackColorList[i])
   
        for e = 1,masterChildCount do
            childTrack = reaper.AZ_InsertChildTrack(track)
            reaper.AZ_SetTrackItemName(childTrack,childInfoList[e].TrackName)
            reaper.AZ_SetTrackItemColor(childTrack,trackColorList[i])
            for x = 1,childInfoList[e].TrackMediaCount do
                newMediaName = reaper.AZ_ReplaceSearchString(childInfoList[e][x].MediaName,string.lower(masterName),string.lower(value))
                for z, value in pairs(fileAllList) do
                    if newMediaName == fileAllList[z].SourceName then
                       reaper.AZ_InsertMediaTrackItemSecond(childTrack,fileAllList[z].Path,0,childInfoList[e][x].MediaPos)
                    end
                end
           
            end
        end
     end
end



